/****************************************************************************
*                                  PE.H                                     *
*****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//                        PE.C     (PHDM's EDITOR)                         //
//                                                                         //
// Copyright (C) 2000-2011  Philippe Demeester                             //
// Bugs reports: phdm@perso.be                                             //
// Web site    : http://phdm.webay.be                                      //
//                                                                         //
// This program is free software; you can redistribute it and/or           //
// modify it under the terms of the GNU General Public                     //
// License as published by the Free Software Foundation; either            //
// version 2.1 of the License, or (at your option) any later version.      //
//                                                                         //
// This program is distributed in the hope that it will be useful,         //
// but WITHOUT ANY WARRANTY; without even the implied warranty of          //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       //
// Library General Public License for more details or write to the         //
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#ifndef _PE_H
#define _PE_H

#include <stddef.h>
#include <stdio.h>
#include <ncurses.h>
#include <string.h>
#include <linux/kd.h>
#include <libintl.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <locale.h>

#include <sys/ioctl.h>
//#include <glib.h>

#define KEY_ESC 27
#define KEY_TAB 9
#define W 256     /* text buffer width */ 
#define BUF 8192  /* text buffer lines */ 
#define BLK 1024  /* block buffer lines */ 
#define Y 23      /* init max curs lines */ 
#define X 79      /* init max curs col's */ 


//GString *gs;
//GList *items;

int txt[BUF][W],block_buf[BLK][W],  /* txt array and block buffers*/
    find_str[128],    /* search string buffer */
    c;                /* current processed char */
char    
    file_name[256],  /* file name buffer */
	home_str[256],		/* keep a copy of env HOME */ 
    curr_dir[256];		/* current file directory */
								
int curs_x,curs_y,  /* cursor place */ 
    curr_line,      /* current line # */ 
    last_line,
    curr_pos,        /* current position in the line */ 
    first_blk_line,
    last_blk_line,
    quit_flg,
	modified,        /* set if txt have been changed */
    xshift,          /* current x shift in buffer for display purpose */  
    last_xshift,
    blk_flg,
    del_blk_flg,
    ym,xm,
    y_max,x_max,
    last_inst_x,last_inst_y, /* last place we were typing */
    tit_flg,       //&tit_flg
    current_color, 
    chr,
    TAB_VAL,
    comfirm_flg,
	utf_8, // flag if LANG is UTF-8 Based
	utf8_valid;
	 
WINDOW *win;

unsigned char a;
/* all functions */
void get_kb(); //&get_kb
void more_in(); //&more_in
void back_spc(); //&back_spc
void delete(); //&delete
void insert(); //&insert
void tab(); //&tab
int eof_line(); //&eof_line
int eof_line_pos(); //&eof_line_pos
void escape(); //&escape
void del_line(); //&del_line
void del_blk(); //&del_blk
void block(int flag); //&block
void page_up(); //&page_up
void ten_pages_up(); //&ten_pages_up
void page_down(); //&page_down
void ten_pages_down(); //&ten_pages_down
void home(); //&home
void start_of_line(); //&start_of_line
void end_of_line(); //&end_of_line
void end(); //&end
void go_left(); //&go_left
void go_right(); //&go_right
void go_up(int flag); //&go_up
void go_down(int flag); //&go_down
void put_line(); //&put_line
void displ_line(); //&displ_line
void new_line(); //&new_line
void move_eol(); //&move_eol
void pscroll_part_down(); //&pscroll_part_down
void shift_txt_down(); //&shift_txt_down
void shift_txt_up(); //&shift_txt_up
void scroll_up(); //&scroll_up
void scroll_down(); //&scroll_down
void redo_scr(); //&redo_sc
void go_last(); //&go_last
void put_cmd(); //&put_cmd
void intro(); //&intro
void put_line_num(); //&put_line_num
void put_cur_pos(); //&put_cur_po
void put_blk_status(); //&put_blk_status
void cls(); //&cls
void cll(); //&cll
void cl_txt_line(); //&cl_txt_line
void loc(int y,int x); //&loc
void reloc(); //&reloc
void load(int flg); //&load
void find(); //&find
int search_line(int i,int l); //&search_line
void save(); //&save
void print(); //&print
void color(int color); //&color
void quit(); //&quit
void init(); //&init
void bip(); //&bip
void tit(); //&tit
void tut(); //&tut
void titat(); //&titat
void tatit(); //&tatit
void titatut(); //&titatut
void info(char *msg); //&info
int ask(char *msg); //&ask
int chk_dspl_len(char c);//&chk_dspl_len
void get_tab_len();//&get_tab_len
void resize_terminal();//&resize_terminal
void redo_full_scr();//&redo_full_scr
void init_tab_len();//&init_tab_len
void set_xshift();//&set_xshift
int is_this_file(char *path);//&is_this_file
int is_this_dir(char *path);//&is_this_dir
void get_fname(int req);//&get_fname
void int_strcpy(int *target, int *src);//&int_strcpy
int int_strlen(int *src);//&int_strlen
int set_curs_pos(int set);//&set_curs_pos
int get_curr_pos(int x);//&get_curr_pos

/* That's it */
#endif // _PE_H
